searchNodes=[{"doc":"Keep time in sync on Nerves devices NervesTime keeps the system clock on Nerves devices in sync when connected to the network and close to in sync when disconnected. It&#39;s especially useful for devices lacking a Battery-backed real-time clock and will advance the clock at startup to a reasonable guess. Nearly all configuration is via the application config (config.exs). The following keys are available: :servers - a list of NTP servers for time synchronization. Specifying an empty list turns off NTP :time_file - a file path for tracking the time. It allows the system to start with a reasonable time quickly on boot and before the Internet is available for NTP to work. :earliest_time - times before this are considered invalid and adjusted :latest_time - times after this are considered invalid and adjusted :ntpd - the absolute path to the Busybox ntpd. This only needs to be set if your system does not provide ntpd in the $PATH.","ref":"NervesTime.html","title":"NervesTime","type":"module"},{"doc":"Return the current NTP servers","ref":"NervesTime.html#ntp_servers/0","title":"NervesTime.ntp_servers/0","type":"function"},{"doc":"Manually restart the NTP daemon This is normally not necessary since NervesTime handles restarting it automatically. An example of a reason to call this function is if you know when the Internet becomes available. For this case, calling restart_ntp will cancel ntpd&#39;s internal timeouts and cause it to immediately send time requests. If using NTP Pool, be sure not to violate its terms of service by calling this function too frequently.","ref":"NervesTime.html#restart_ntpd/0","title":"NervesTime.restart_ntpd/0","type":"function"},{"doc":"Set the list of NTP servers Use this function to replace the list of NTP servers that are queried for time. It is also possible to set this list in your config.exs by doing something like the following: config :nerves_time, :servers, [ &quot;0.pool.ntp.org&quot;, &quot;1.pool.ntp.org&quot;, &quot;2.pool.ntp.org&quot;, &quot;3.pool.ntp.org&quot; ] NervesTime uses NTP Pool by default. To disable this and configure servers solely at runtime, specify an empty list in config.exs: config :nerves_time, :servers, []","ref":"NervesTime.html#set_ntp_servers/1","title":"NervesTime.set_ntp_servers/1","type":"function"},{"doc":"Check whether NTP is synchronized with the configured NTP servers It&#39;s possible that the time is already set correctly when this returns false. NervesTime decides that NTP is synchronized when ntpd sends a notification that the device&#39;s clock stratum is 4 or less. Clock adjustments occur before this, though. Once NTP is synchronized, it will remain that way until the nerves_time application is restarted.","ref":"NervesTime.html#synchronized?/0","title":"NervesTime.synchronized?/0","type":"function"},{"doc":"FileTime simulates a real-time clock using a file&#39;s mtime The way it works is that a file is touched each time nerves_time wants to update the RTC. When nerves_time shuts down, the file is again touched. The next boot then reads the last modified time of the file so that nerves_time can set the clock to that value. It will certainly be off, but not absurdly so unless the device has been powered off for a really long time. While this doesn&#39;t sound ideal at all, knowing the time within minutes, hours, or days can get the clock to within time ranges needed for X.509 certificate validation.","ref":"NervesTime.FileTime.html","title":"NervesTime.FileTime","type":"module"},{"doc":"Return the timestamp of when update was last called or the Unix epoch time (1970-01-01) should that not work.","ref":"NervesTime.FileTime.html#get_time/1","title":"NervesTime.FileTime.get_time/1","type":"function"},{"doc":"Update the file holding a stamp of the current time.","ref":"NervesTime.FileTime.html#set_time/2","title":"NervesTime.FileTime.set_time/2","type":"function"},{"doc":"Update the timestamp one final time","ref":"NervesTime.FileTime.html#terminate/1","title":"NervesTime.FileTime.terminate/1","type":"function"},{"doc":"Return the path to the file that keeps track of the time","ref":"NervesTime.FileTime.html#time_file/0","title":"NervesTime.FileTime.time_file/0","type":"function"},{"doc":"Behaviour for real-time clocks implementations.","ref":"NervesTime.RealTimeClock.html","title":"NervesTime.RealTimeClock","type":"behaviour"},{"doc":"Get the time from the clock This is called after init/1 returns successfully to see if the system clock should be updated. If the time isn&#39;t set, the implementation should return :unset. set_time/2 will be called when the time is known.","ref":"NervesTime.RealTimeClock.html#c:get_time/1","title":"NervesTime.RealTimeClock.get_time/1","type":"callback"},{"doc":"Initialize the clock This is called when nerves_time starts. If it fails, nerves_time won&#39;t call any of the other functions.","ref":"NervesTime.RealTimeClock.html#c:init/1","title":"NervesTime.RealTimeClock.init/1","type":"callback"},{"doc":"Set the clock This is called if nerves_time determines that the implementation is out of sync with the true time and at regular intervals (usually 11 minutes) as updates come in from NTP. If the time can&#39;t be set, the implementation can either wait to be called the next time or take some other action.","ref":"NervesTime.RealTimeClock.html#c:set_time/2","title":"NervesTime.RealTimeClock.set_time/2","type":"callback"},{"doc":"Clean up the clock state This is called when nerves_time terminates. It&#39;s not guaranteed to be called, but if it is, it should clean up or do any final operations on the RTC.","ref":"NervesTime.RealTimeClock.html#c:terminate/1","title":"NervesTime.RealTimeClock.terminate/1","type":"callback"},{"doc":"Internal state of the hardware clock","ref":"NervesTime.RealTimeClock.html#t:state/0","title":"NervesTime.RealTimeClock.state/0","type":"type"},{"doc":"Convert between integers and binary-coded decimals (BCD) BCD is commonly used in Real-time clock chips for historical reasons. See wikipedia.org/wiki/Binary-coded_decimal for a good background on BCD. The BCD implementation here is referred to as &quot;Packed BCD&quot; in the article.","ref":"NervesTime.RealTimeClock.BCD.html","title":"NervesTime.RealTimeClock.BCD","type":"module"},{"doc":"Convert a 8 bit integer value to a BCD binary","ref":"NervesTime.RealTimeClock.BCD.html#from_integer/1","title":"NervesTime.RealTimeClock.BCD.from_integer/1","type":"function"},{"doc":"Convert an 8 bit bcd-encoded value to an integer","ref":"NervesTime.RealTimeClock.BCD.html#to_integer/1","title":"NervesTime.RealTimeClock.BCD.to_integer/1","type":"function"},{"doc":"Support two digit BCD","ref":"NervesTime.RealTimeClock.BCD.html#t:t/0","title":"NervesTime.RealTimeClock.BCD.t/0","type":"type"},{"doc":"nerves_time NervesTime keeps the system clock on Nerves devices in sync when connected to the network and close to in sync when disconnected. It&#39;s especially useful for devices lacking a Battery-backed real-time clock and will advance the clock at startup to a reasonable guess.","ref":"readme.html","title":"nerves_time","type":"extras"},{"doc":"First add nerves_time to your project&#39;s dependencies: def deps do [ {:nerves_time, &quot;~&gt; 0.3.0&quot;} ] end Ensure that your vm.args allows for timewarps. If it doesn&#39;t, nerves_time will update the OS system time, but Erlang&#39;s system time will lag. The following line should be in the beginning or middle of the vm.args file: +C multi_time_warp If you&#39;re using one of the official Nerves Systems, then this is all that&#39;s needed. nerves_time requires Busybox&#39;s ntpd and date applets to be enabled. If you haven&#39;t explicitly disabled the, they&#39;re probably enabled.","ref":"readme.html#installation","title":"nerves_time - Installation","type":"extras"},{"doc":"nerves_time uses ntp.pool.org for time synchronization. Please see their terms of use before tweaking nerves_time. Alternative NTP servers can be specified using the config.exs: # config/config.exs config :nerves_time, :servers, [ &quot;0.pool.ntp.org&quot;, &quot;1.pool.ntp.org&quot;, &quot;2.pool.ntp.org&quot;, &quot;3.pool.ntp.org&quot; ] It&#39;s also possible to configure NTP servers at runtime. See NervesTime.set_ntp_servers/1. nerves_time also has a concept of a valid time range. This minimizes time errors on systems without clocks or Internet connections or that may have some issue that causes a very wrong time value. The default valid time range is hardcoded and moves forward each release. It is not the build timestamp since that results in non-reproducible builds. Applications can override the valid range via the application config: # config/config.exs config :nerves_time, earliest_time: ~N[2019-10-04 00:00:00], latest_time: ~N[2022-01-01 00:00:00]","ref":"readme.html#configuration","title":"nerves_time - Configuration","type":"extras"},{"doc":"Here&#39;s the basic idea behind nerves_time: If the clock hasn&#39;t been set or is invalid, set it to the earliest valid time known to nerves_time. This is either set in the application config or defaulted to a reasonable value that likely moves forward a little each nerves_time release. check for time via a Real Time Clock Run Busybox ntpd to synchronize time using the NTP protocol. Update Real Time Clock periodically and on graceful power downs. This is currently only done at around 11 minute intervals. To check the NTP synchronization status, call NervesTime.synchronized?/0.","ref":"readme.html#algorithm","title":"nerves_time - Algorithm","type":"extras"},{"doc":"A hardware based real time clock can be configured by added a config.exs entry: config :nerves_time, rtc: {SomeImplementingModule, [some: :initialization_opt]} By default Nerves Time is configured to use NervesTime.FileTime which will Check for ~/.nerves_time. If it exists, advance the clock to it&#39;s last modification time. See the documentation for NervesTime.RealTimeClock to implement your own real time clock.","ref":"readme.html#real-time-clock","title":"nerves_time - Real Time Clock","type":"extras"},{"doc":"This project started as a fork of nerves_ntp by Marcin Operacz and Wojciech Mandrysz. It has quite a few changes from since when they worked on the project, but some of their code still exists. Both their project and this one are covered by the Apache-2.0 license.","ref":"readme.html#credits-and-license","title":"nerves_time - Credits and license","type":"extras"}]